<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Compcard extends Base\Compcard
{

    /**
     * @return \Planejamento\Entities\Prato
     */
    public function getPrato() {
        $id = array(
            "cdfilauxprat" => $this->cdfilauxprat,
            "cdprato" => $this->cdprato,
            "nrorg" => $this->nrorg,
        );
        $prato = \Planejamento\Entities\Prato::getObject($id);
        return $prato;
    }

    public static function deleta($nrorg, $cdfilial, $nrcardapio)
    {
        try {
            $compcard = Compcard::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND NRCARDAPIO = ?',
                array($nrorg, $cdfilial, $nrcardapio)
            );

            if ($compcard instanceof Compcard) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $compcard->delete();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    public static function atualizaComensais(
        $nrorg, $cdfilial, $nrcardapio, $nrseqpratcar, $vrpeconscard
    )
    {
        try {
            $compcard = Compcard::getObjectByWhere(
                'NRORG = ? AND CDFILIAL = ? AND NRCARDAPIO = ? AND NRSEQPRATCAR = ?',
                array($nrorg, $cdfilial, $nrcardapio, $nrseqpratcar)
            );

            if ($compcard instanceof Compcard) {
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();

                $compcard->setVrpeconscard($vrpeconscard);
                $compcard->setNrorgultatu($nrorg);
                $compcard->setDtultatu(DateUtil::getDataAtual());
                $compcard->setCdoperultatu(Ambiente::getCdoperador());
                $compcard->persist();

                $connection->flush();
                $connection->commit();
            }

            return true;
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }
}