/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: DUPLICA_COTACAO

Descrio:
Duplica cotaes

Criao:
03/04/2000 - Yoris L. de Souza

PARAMETROS:
@C:\WIN_V4\SQL\END_CONV\SQLSERVER\8300_SUPSTPO.SQL
IdMotivNDupl Identificador do motivo da no duplicao.

IdMotivNDupl [1] = '1' Fornecedor inativo
IdMotivNDupl [2] = '1' Fornecedor no atende  regio
IdMotivNDupl [3] = '1' Qualificao de produto por fornecedor
IdMotivNDupl [4] = '1' Qualificao de marca por produto
IdMotivNDupl [5] = '1' Qualificao de fornecedor
IdMotivNDupl [6] = '1' Produto no cadastrado para o fornecedor
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DUPLICA_COTACAO'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)

   DROP PROCEDURE DUPLICA_COTACAO;
GO
CREATE PROCEDURE DUPLICA_COTACAO
   @P_CDFILIAL     VARCHAR(4),
   @P_CDFILIPROC   VARCHAR(4),
   @P_NRCOLEPRECO  VARCHAR(10),
   @P_NRSEMAINIC   VARCHAR(2),
   @P_NRSEMAFINAL  VARCHAR(2),
   @P_DTNOVINIVAL  DATETIME,
   @P_DTNOVFINVAL  DATETIME,
   @P_DTINIVALCOL  DATETIME,
   @P_DTFINVALCOL  DATETIME,
   @P_DTCOLEPREC   DATETIME,
   @P_REAJUSTE     NUMERIC(10,5),
   @P_NRCOLEDUP    VARCHAR(10),
   @P_IDDUPLICA    VARCHAR(1),
   @P_CDOPERADOR   VARCHAR(2000) = NULL,
   @P_TCDOPERADOR  VARCHAR(1),
   @P_CDOPERINCL   VARCHAR(12),
   @P_CDREGIAO     VARCHAR(2000) = NULL,
   @P_COTA_N_DUP   VARCHAR(50) OUTPUT

AS
   DECLARE @V_NRCOLEPRECO  VARCHAR(10);
   DECLARE @V_NRCOLEORIG   VARCHAR(10);
   DECLARE @V_CDOPERADOR   VARCHAR(12);
   DECLARE @V_IDDISMONTLIS VARCHAR(01);

   DECLARE @V_COUNT    INT;
   DECLARE @V_COUNTAUX INT;
   DECLARE @V_MARCAAUX INT;


   DECLARE @V_PGTO_CDFORMPGTO   VARCHAR(2);
   DECLARE @V_PGTO_IDTPFORPGPRF VARCHAR(1);
   DECLARE @V_PGTO_NRPARCPGTPRF NUMERIC(2);
   DECLARE @V_PGTO_NRDIAPGFIPRF NUMERIC(2);
   DECLARE @V_PGTO_IDUTDIAPGPRF VARCHAR(1);

   DECLARE @V_PGTO_IDTPFORPGTFO VARCHAR(1);
   DECLARE @V_PGTO_NRPARCPGTOFO NUMERIC(2);
   DECLARE @V_PGTO_NRDIAPGFIXFO NUMERIC(2);
   DECLARE @V_PGTO_IDUTDIAPGTFO VARCHAR(1);
   DECLARE @V_PGTO_IDTPDESCFORN VARCHAR(1);
   DECLARE @V_PGTO_VRPEDESCFORN NUMERIC(10, 2);
   DECLARE @V_PGTO_IDTPFRETFORN VARCHAR(1);

   DECLARE @V_ITEMCOLE_CDFILIAL     VARCHAR(4);
   DECLARE @V_ITEMCOLE_NRCOLEPRECO  VARCHAR(10);
   DECLARE @V_ITEMCOLE_CDFORNECED   VARCHAR(21);
   DECLARE @V_ITEMCOLE_CDREGIAO     VARCHAR(3);
   DECLARE @V_ITEMCOLE_CDPRODUTO    VARCHAR(10);
   DECLARE @V_ITEMCOLE_CDARVPROD    VARCHAR(20);
   DECLARE @V_ITEMCOLE_CDMARCA      VARCHAR(5);
   DECLARE @V_ITEMCOLE_CDTIPCOB     VARCHAR(2);
   DECLARE @V_ITEMCOLE_CDSEGMARCCOL VARCHAR(5);
   DECLARE @V_ITEMCOLE_DTNOVINIVAL  DATETIME;
   DECLARE @V_ITEMCOLE_DTNOVFINVAL  DATETIME;
   DECLARE @V_ITEMCOLE_VRPRECUNIITM NUMERIC(15, 5);
   DECLARE @V_ITEMCOLE_VRPRECECOITM NUMERIC(15, 5);
   DECLARE @V_ITEMCOLE_VRPERDESITM  NUMERIC(6, 2);
   DECLARE @V_ITEMCOLE_IDTIPFREITM  VARCHAR(1);
   DECLARE @V_ITEMCOLE_NRPZOENTCOL  VARCHAR(1);
   DECLARE @V_ITEMCOLE_CDFORMPGTO   VARCHAR(2);
   DECLARE @V_ITEMCOLE_IDTPFOPGTCOL VARCHAR(1);
   DECLARE @V_ITEMCOLE_NRPARCPGTCOL NUMERIC(2);
   DECLARE @V_ITEMCOLE_NRDIAPGFXCOL NUMERIC(2);
   DECLARE @V_ITEMCOLE_IDUTDIAPGCOL VARCHAR(1);
   DECLARE @V_ITEMCOLE_DSPZOPGTCONC VARCHAR(2000);
   DECLARE @V_ITEMCOLE_IDSITUCADA   VARCHAR(1);
   DECLARE @V_ITEMCOLE_CDQUALIF     VARCHAR(2);
   DECLARE @V_ITEMCOLE_IDFORNAUTO   VARCHAR(1);
   DECLARE @V_ITEMCOLE_DTVALQUALIF  DATETIME;

   DECLARE @V_IDMOTIVNDUPL VARCHAR(10);
   DECLARE @V_DSMETUSULIC VARCHAR(50);
   DECLARE @V_IDUTISTATCOT VARCHAR(1);
   DECLARE @V_IDSITUCOLETA VARCHAR(1);
   DECLARE @V_IDCOTCONCLUI VARCHAR(1);

   DECLARE @V_CDEMPRESA  VARCHAR(2);
   DECLARE @V_CDINSCESTA VARCHAR(16);

   DECLARE @V_PRXCOLETA  VARCHAR(20);
   DECLARE @V_AUX        VARCHAR(50);

   DECLARE @V_NMOPERADOR     VARCHAR(250);
   DECLARE @V_DSREMOTEADDR   VARCHAR(50);
   DECLARE @V_DSREMOTEHOST   VARCHAR(50);
   DECLARE @V_DSSERVERRDM    VARCHAR(50);
   DECLARE @V_DSSERVMETHOD   VARCHAR(250);
   DECLARE @V_DSREMOTEOPER   VARCHAR(12);

   DECLARE @V_NRCOLEPRECO_AUX  VARCHAR(10);
   DECLARE @V_CDREGIAO VARCHAR(03);
   DECLARE @V_LIMPEZA_CDFILIAL VARCHAR(04);
   DECLARE @V_LIMPEZA_NRCOLEPRECO VARCHAR(10);
   DECLARE @V_CONTADOR INT;
BEGIN
   SET @V_DSMETUSULIC = '8300_SUPSTPO_DUPLICA_COTACAO';

   SELECT
      @V_IDUTISTATCOT = MAX(ISNULL(IDUTISTATCOT, 'N')),
      @V_IDCOTCONCLUI = MAX(ISNULL(IDCOTCONCLUI, 'N'))
   FROM
      PARASUPRI
   WHERE
      CDFILIAL = @P_CDFILIAL;

   IF @V_IDUTISTATCOT = 'S' BEGIN
      SET @V_IDSITUCOLETA = 'A';
   END ELSE BEGIN
      SET @V_IDSITUCOLETA = 'C'; --//DIF
   END;                  
   
   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;
   IF @V_DSREMOTEOPER IS NULL BEGIN                 
      SELECT @V_DSREMOTEOPER = CONVERT(VARCHAR, MAX(DSREMOTEOPER)) FROM SQLWEBTUNNING WHERE @@SPID = NRAUDSID;
   END;
   DECLARE C_COTACAO CURSOR FOR
     SELECT NRCOLEPRECO, COLETAPR.CDOPERADOR, IDDISMONTLIS
       FROM COLETAPR
      WHERE ((CHARINDEX(COLETAPR.CDOPERADOR, @P_CDOPERADOR) <> 0) OR
            ((@P_TCDOPERADOR = 'T') AND COLETAPR.CDOPERADOR IN ((SELECT C.CDOPERADOR
                                                                   FROM COMPROPER CO, COMPRADOR C, OPERADOR O
                                                                  WHERE CO.IDCOTCMPOPER = 'S'
                                                                    AND CO.CDCOMPRADOR  = C.CDOPERADOR
                                                                    AND CO.CDOPERADOR   = ISNULL(@V_DSREMOTEOPER,CO.CDOPERADOR)
                                                                    AND O.CDOPERADOR    = C.CDOPERADOR
                                                                  UNION
                                                                 SELECT C.CDOPERADOR
                                                                   FROM COMPRADOR C, OPERADOR O
                                                                  WHERE C.CDOPERADOR = O.CDOPERADOR
                                                                    AND C.CDOPERADOR = ISNULL(@V_DSREMOTEOPER,C.CDOPERADOR)))))
        AND (CDFILIAL     = @P_CDFILIAL)
        AND ((@P_IDDUPLICA = '1' AND DTINIVALCOL >= @P_DTINIVALCOL AND DTFINVALCOL <= @P_DTFINVALCOL) OR
            (@P_IDDUPLICA  = '2' AND NRCOLEPRECO = @P_NRCOLEDUP))
        AND EXISTS (SELECT 1
                      FROM ITEMCOLE
                     WHERE ITEMCOLE.CDFILIAL    = COLETAPR.CDFILIAL
                       AND ITEMCOLE.NRCOLEPRECO = COLETAPR.NRCOLEPRECO);

  OPEN C_COTACAO;
  FETCH NEXT FROM C_COTACAO INTO @V_NRCOLEORIG,
                                 @V_CDOPERADOR,
                                 @V_IDDISMONTLIS

  WHILE (@@FETCH_STATUS = 0)
  BEGIN
    SET @V_AUX = 'COLETA'+@P_CDFILIAL;
    EXEC NOVO_CODIGO @V_AUX, @P_SEQUENCIAL = @V_PRXCOLETA OUTPUT, @P_QTDE = 1;
    SET @V_NRCOLEPRECO = SUBSTRING(@V_PRXCOLETA,11,10);
    SET @P_COTA_N_DUP  = 'N'+@V_NRCOLEPRECO;

    INSERT INTO COLETAPR
       (CDFILIAL,
        NRCOLEPRECO,
        NRSEMAINIC,
        NRSEMAFINAL,
        DTINIVALCOL,
        DTFINVALCOL,
        CDOPERADOR,
        DTCOLEPREC,
        NRCOLEORIGCO,
        CDOPERINCL,
        DTINCLCOLET,
        IDDISMONTLIS,
        IDSITUCOLETA)
    VALUES
       (@P_CDFILIAL,
        @V_NRCOLEPRECO,
        @P_NRSEMAINIC ,
        @P_NRSEMAFINAL,
        @P_DTNOVINIVAL,
        @P_DTNOVFINVAL,
        @V_CDOPERADOR,
        @P_DTCOLEPREC,
        @V_NRCOLEORIG,
        @P_CDOPERINCL,
        GETDATE(),
        @V_IDDISMONTLIS,
        @V_IDSITUCOLETA);

    DECLARE C_REGIAO CURSOR FOR
        SELECT CDREGIAO
          FROM REGIAO
         WHERE CHARINDEX(REGIAO.CDREGIAO, ISNULL(@P_CDREGIAO, REGIAO.CDREGIAO)) <> 0
           AND EXISTS (SELECT 1
                         FROM ITEMCOLE
                        WHERE ITEMCOLE.CDFILIAL    = @P_CDFILIAL
                          AND ITEMCOLE.NRCOLEPRECO = @V_NRCOLEORIG
                          AND ITEMCOLE.CDREGIAO    = REGIAO.CDREGIAO);

     OPEN C_REGIAO;
     FETCH NEXT FROM C_REGIAO INTO @V_CDREGIAO

     WHILE (@@FETCH_STATUS = 0)
     BEGIN

       DECLARE C_ITEMCOLE CURSOR FOR
                          SELECT I.CDFILIAL, @V_NRCOLEPRECO AS NRCOLEPRECO, I.CDFORNECED, I.CDREGIAO,
                                 I.CDPRODUTO, P.CDARVPROD, I.CDMARCA, I.CDTIPCOB,
                                 I.CDSEGMARCCOL, @P_DTNOVINIVAL AS DTNOVINIVAL, @P_DTNOVFINVAL AS DTNOVFINVAL,
                                 I.VRPRECUNIITM + ((I.VRPRECUNIITM * @P_REAJUSTE) / 100) AS VRPRECUNIITM,
                                 I.VRPRECECOITM, I.VRPERDESITM, I.IDTIPFREITM, I.NRPZOENTCOL,
                                 I.CDFORMPGTO, I.IDTPFOPGTCOL, I.NRPARCPGTCOL, I.NRDIAPGFXCOL,
                                 I.IDUTDIAPGCOL, I.DSPZOPGTCONC, F.IDSITUCADA, F.CDQUALIF,
                                 F.IDFORNAUTO, F.DTVALQUALIF
                            FROM ITEMCOLE I INNER JOIN PRODUTO    P ON P.CDPRODUTO  = I.CDPRODUTO
                                            INNER JOIN FORNECEDOR F ON F.CDFORNECED = I.CDFORNECED
                           WHERE I.CDFILIAL     = @P_CDFILIAL
                             AND I.NRCOLEPRECO  = @V_NRCOLEORIG
                             AND I.CDREGIAO     = @V_CDREGIAO;

       OPEN C_ITEMCOLE;
       FETCH NEXT FROM C_ITEMCOLE INTO @V_ITEMCOLE_CDFILIAL,
                                       @V_ITEMCOLE_NRCOLEPRECO,
                                       @V_ITEMCOLE_CDFORNECED,
                                       @V_ITEMCOLE_CDREGIAO,
                                       @V_ITEMCOLE_CDPRODUTO,
                                       @V_ITEMCOLE_CDARVPROD,
                                       @V_ITEMCOLE_CDMARCA,
                                       @V_ITEMCOLE_CDTIPCOB,
                                       @V_ITEMCOLE_CDSEGMARCCOL,
                                       @V_ITEMCOLE_DTNOVINIVAL,
                                       @V_ITEMCOLE_DTNOVFINVAL,
                                       @V_ITEMCOLE_VRPRECUNIITM,
                                       @V_ITEMCOLE_VRPRECECOITM,
                                       @V_ITEMCOLE_VRPERDESITM,
                                       @V_ITEMCOLE_IDTIPFREITM,
                                       @V_ITEMCOLE_NRPZOENTCOL,
                                       @V_ITEMCOLE_CDFORMPGTO,
                                       @V_ITEMCOLE_IDTPFOPGTCOL,
                                       @V_ITEMCOLE_NRPARCPGTCOL,
                                       @V_ITEMCOLE_NRDIAPGFXCOL,
                                       @V_ITEMCOLE_IDUTDIAPGCOL,
                                       @V_ITEMCOLE_DSPZOPGTCONC,
                                       @V_ITEMCOLE_IDSITUCADA,
                                       @V_ITEMCOLE_CDQUALIF,
                                       @V_ITEMCOLE_IDFORNAUTO,
                                       @V_ITEMCOLE_DTVALQUALIF;


       WHILE (@@FETCH_STATUS = 0)
       BEGIN
          IF ((@V_IDUTISTATCOT = 'S') AND (@V_IDCOTCONCLUI = 'S')) BEGIN
             SELECT @V_NRCOLEPRECO_AUX = MAX(I.NRCOLEPRECO)
               FROM ITEMCOLE I INNER JOIN COLETAPR C ON C.CDFILIAL    = I.CDFILIAL
                                                    AND C.NRCOLEPRECO = I.NRCOLEPRECO
              WHERE I.CDFILIAL    = @V_ITEMCOLE_CDFILIAL
                AND I.NRCOLEPRECO <> @V_ITEMCOLE_NRCOLEPRECO
                AND I.CDMARCA     = @V_ITEMCOLE_CDMARCA
                AND I.CDREGIAO    = @V_ITEMCOLE_CDREGIAO
                AND I.CDFORNECED  = @V_ITEMCOLE_CDFORNECED
                AND I.CDPRODUTO   = @V_ITEMCOLE_CDPRODUTO
                AND C.DTINIVALCOL = @V_ITEMCOLE_DTNOVINIVAL
                AND C.DTFINVALCOL = @V_ITEMCOLE_DTNOVFINVAL
                AND ISNULL(C.IDSITUCOLETA, 'C') = 'C';

             IF @V_NRCOLEPRECO_AUX IS NOT NULL BEGIN
                SET @P_COTA_N_DUP = 'S'+@V_ITEMCOLE_NRCOLEPRECO;
                INSERT INTO LOGITEMCOLE
                     (CDFILIALLIC,  NRCOLEPRELIC, CDMARCALIC,   CDREGIAOLIC,
                      CDFORNECELIC, CDPRODUTOLIC, DTINIVALLIC,  DTFINVALLIC,
                      DTOPERACLIC,  IDOPERALIC,   DSMETUSULIC,  IDITMLISPLIC,
                      NRCOLEORILIC, IDMOTIVNDUPL, VRPRECANTLIC, VRPRECDEPLIC)
                    VALUES
                     (@V_ITEMCOLE_CDFILIAL, @V_ITEMCOLE_NRCOLEPRECO, @V_ITEMCOLE_CDMARCA, @V_ITEMCOLE_CDREGIAO,
                      @V_ITEMCOLE_CDFORNECED, @V_ITEMCOLE_CDPRODUTO, @V_ITEMCOLE_DTNOVINIVAL, @V_ITEMCOLE_DTNOVFINVAL,
                      GETDATE(), 'N', @V_DSMETUSULIC, 'N',
                      @V_NRCOLEORIG, '0000001000', @V_ITEMCOLE_VRPRECUNIITM, @V_ITEMCOLE_VRPRECUNIITM);
                --CONTINUE;
             END;
          END;

          IF @V_NRCOLEPRECO_AUX IS NULL BEGIN
             SET @V_IDMOTIVNDUPL = '';
             SET @V_MARCAAUX     = NULL;
             
          /* IdMotivNDupl [1] = '1' Fornecedor inativo */
             IF @V_ITEMCOLE_IDSITUCADA = 'I' BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END;

          /* IdMotivNDupl [2] = '1' Fornecedor no atende  regio */
             SET @V_COUNT = 0;
             SELECT
                @V_COUNT = COUNT(1)
             FROM
                REFOREG
             WHERE
                @V_ITEMCOLE_CDREGIAO   = REFOREG.CDREGIAO   AND
                @V_ITEMCOLE_CDFORNECED = REFOREG.CDFORNECED;

             IF @V_COUNT <> 0 BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END;

          /* IdMotivNDupl [3] = '1' Qualificao de produto por fornecedor */
             SET @V_COUNT = 0;
             SELECT
                @V_COUNT = COUNT(1)
             FROM
                QFOPRODFORN,
                PARASUPRI
             WHERE
                (PARASUPRI.CDFILIAL     = @P_CDFILIAL)            AND
                (QFOPRODFORN.CDPRODUTO  = @V_ITEMCOLE_CDPRODUTO)  AND
                (QFOPRODFORN.CDFORNECED = @V_ITEMCOLE_CDFORNECED) AND
                ((QFOPRODFORN.IDFORNAPROV = 'N'    AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
                 ((QFOPRODFORN.IDFORNAPROV = 'S')  AND
                    ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                      @P_DTCOLEPREC > (DATEADD(MM,1,QFOPRODFORN.DTVALPRFORN)- DAY(DATEADD(MM,1,QFOPRODFORN.DTVALPRFORN)))) OR
                     (PARASUPRI.IDULTIDTVALQ = 'D' AND
                      @P_DTCOLEPREC > QFOPRODFORN.DTVALPRFORN))));

             IF @V_COUNT <> 0 BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END;

          /* IdMotivNDupl [4] = '1' Qualificao de marca por produto */
             SET @V_COUNT = 0;
             SELECT
                @V_COUNT = COUNT(1)
             FROM
                QFOMARPROD,
                PARASUPRI
             WHERE
               (PARASUPRI.CDFILIAL   = @P_CDFILIAL)           AND
               (QFOMARPROD.CDPRODUTO = @V_ITEMCOLE_CDPRODUTO) AND
               (QFOMARPROD.CDMARCA   = @V_ITEMCOLE_CDMARCA)   AND
               ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
                ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                   ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                     @P_DTCOLEPREC > (DATEADD(MM,1,QFOMARPROD.DTVALAPROVA)- DAY(DATEADD(MM,1,QFOMARPROD.DTVALAPROVA)))) OR
                    (PARASUPRI.IDULTIDTVALQ = 'D' AND
                     @P_DTCOLEPREC > QFOMARPROD.DTVALAPROVA))) );

             SET @V_COUNTAUX = 0;
             SELECT @V_COUNTAUX = COUNT(1)
               FROM QFOMARPROD
              WHERE QFOMARPROD.CDPRODUTO = @V_ITEMCOLE_CDPRODUTO 
                AND QFOMARPROD.CDMARCA   = @V_ITEMCOLE_CDMARCA;

             IF @V_COUNTAUX = 0 BEGIN
                SELECT @V_MARCAAUX = PARASUPRI.CDMARCA
                  FROM PARASUPRI
                 WHERE (PARASUPRI.CDFILIAL     = @P_CDFILIAL) 
                   AND (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL);
             END;

             IF (@V_COUNT = 0) AND ((@V_COUNTAUX <> 0) OR (@V_MARCAAUX IS NOT NULL)) BEGIN

             --IF (@V_COUNT = 0) AND (@V_COUNTAUX <> 0) BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END;

             --IF @V_COUNTAUX = 0 BEGIN
             --   SELECT
             --      @V_MARCAAUX = PARASUPRI.CDMARCA
             --   FROM
             --      PARASUPRI
             --   WHERE
             --      (PARASUPRI.CDFILIAL     = @P_CDFILIAL) AND
             --      (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL);
             --END;

          /* IdMotivNDupl [5] = '1' Qualificao de fornecedor */
             SET @V_COUNT = 0;
             SELECT
                @V_COUNT = COUNT(1)
             FROM
                QUALIFICACAO,
                PARASUPRI
             WHERE
                (@V_ITEMCOLE_CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
                (PARASUPRI.CDFILIAL         = @P_CDFILIAL)           AND
                (@V_ITEMCOLE_IDFORNAUTO     = 'N')                   AND
                ((QUALIFICACAO.IDPERCOTCMP  = '2')                   OR
                 ((PARASUPRI.IDULTIDTVALQ   = 'D'                    AND
                   @P_DTNOVFINVAL > @V_ITEMCOLE_DTVALQUALIF)           OR
                 (PARASUPRI.IDULTIDTVALQ = 'M'                       AND
                  @P_DTNOVFINVAL > (DATEADD(MM,1,@V_ITEMCOLE_DTVALQUALIF)- DAY(DATEADD(MM,1,@V_ITEMCOLE_DTVALQUALIF))))));

             IF @V_COUNT <> 0 BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END;

          /* IdMotivNDupl [6] = '1' Produto no cadastrado para o fornecedor */
             SET @V_COUNT = 0;
             SELECT
                @V_COUNT = COUNT(1)
             FROM
                PRODFORN,
                PRODUTO PRODUTO_PRODFORN
             WHERE
                (PRODFORN.CDPRODUTO  = PRODUTO_PRODFORN.CDPRODUTO) AND
                (PRODFORN.CDFORNECED = @V_ITEMCOLE_CDFORNECED)     AND
                (@V_ITEMCOLE_CDARVPROD LIKE PRODUTO_PRODFORN.CDARVPROD+'%');

             IF @V_COUNT = 0  BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '1';
             END
             ELSE
             BEGIN
                SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL + '0';
             END;

             SET @V_IDMOTIVNDUPL = @V_IDMOTIVNDUPL+'0000';

             IF @V_IDMOTIVNDUPL = '0000000000' BEGIN
                INSERT INTO ITEMCOLE
                 (CDFILIAL,
                  NRCOLEPRECO,
                  CDFORNECED,
                  CDREGIAO,
                  CDPRODUTO,
                  CDMARCA,
                  CDTIPCOB,
                  CDSEGMARCCOL,
                  DTINIVALITM,
                  DTFINVALITM,
                  VRPRECUNIITM,
                  VRPRECECOITM,
                  VRPERDESITM,
                  IDTIPFREITM,
                  NRPZOENTCOL,
                  DSPZOPGTCONC,
                  NRCOLEORIGIC,
                  CDOPERINCL,
                  IDPRECALT,
                  DTINCLITMCOL)
                VALUES
                 (@V_ITEMCOLE_CDFILIAL,
                  @V_ITEMCOLE_NRCOLEPRECO,
                  @V_ITEMCOLE_CDFORNECED,
                  @V_ITEMCOLE_CDREGIAO,
                  @V_ITEMCOLE_CDPRODUTO,
                  @V_ITEMCOLE_CDMARCA,
                  @V_ITEMCOLE_CDTIPCOB,
                  @V_ITEMCOLE_CDSEGMARCCOL,
                  @V_ITEMCOLE_DTNOVINIVAL,
                  @V_ITEMCOLE_DTNOVFINVAL,
                  @V_ITEMCOLE_VRPRECUNIITM,
                  @V_ITEMCOLE_VRPRECECOITM,
                  @V_ITEMCOLE_VRPERDESITM,
                  @V_ITEMCOLE_IDTIPFREITM,
                  @V_ITEMCOLE_NRPZOENTCOL,
                  @V_ITEMCOLE_DSPZOPGTCONC,
                  @V_NRCOLEORIG,
                  @P_CDOPERINCL,
                  'N',
                  GETDATE());

      /*############################# FORMA DE PAGAMENTO ##############################*/
                SET @V_PGTO_CDFORMPGTO   = NULL;
                SET @V_PGTO_IDTPFORPGPRF = NULL;
                SET @V_PGTO_NRPARCPGTPRF = NULL;
                SET @V_PGTO_NRDIAPGFIPRF = NULL;
                SET @V_PGTO_IDUTDIAPGPRF = NULL;
                SELECT
                   @V_PGTO_CDFORMPGTO   = MAX(PRODFORN.CDFORMPGTO),
                   @V_PGTO_IDTPFORPGPRF = MAX(PRODFORN.IDTPFORPGPRF),
                   @V_PGTO_NRPARCPGTPRF = MAX(PRODFORN.NRPARCPGTPRF),
                   @V_PGTO_NRDIAPGFIPRF = MAX(PRODFORN.NRDIAPGFIPRF),
                   @V_PGTO_IDUTDIAPGPRF = MAX(PRODFORN.IDUTDIAPGPRF)
                FROM
                  PRODFORN, PRODUTO
                WHERE
                  PRODFORN.CDPRODUTO  = PRODUTO.CDPRODUTO AND
                  PRODFORN.CDFORNECED = @V_ITEMCOLE_CDFORNECED AND
                  PRODUTO.CDARVPROD   = (SELECT MAX(PRODUTO.CDARVPROD)
                                           FROM PRODFORN, PRODUTO
                                          WHERE PRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO
                                            AND PRODFORN.CDFORNECED = @V_ITEMCOLE_CDFORNECED
                                            AND @V_ITEMCOLE_CDARVPROD LIKE PRODUTO.CDARVPROD + '%');

                IF @V_PGTO_IDTPFORPGPRF IS NULL BEGIN
                   SET @V_PGTO_CDFORMPGTO   = NULL;
                   SET @V_PGTO_IDTPFORPGTFO = NULL;
                   SET @V_PGTO_NRPARCPGTOFO = NULL;
                   SET @V_PGTO_NRDIAPGFIXFO = NULL;
                   SET @V_PGTO_IDUTDIAPGTFO = NULL;
                   SET @V_PGTO_IDTPDESCFORN = NULL;
                   SET @V_PGTO_VRPEDESCFORN = NULL;
                   SET @V_PGTO_IDTPFRETFORN = NULL;
                   SELECT
                      @V_PGTO_CDFORMPGTO   = CDFORMPGTO,
                      @V_PGTO_IDTPFORPGTFO = IDTPFORPGTFO,
                      @V_PGTO_NRPARCPGTOFO = NRPARCPGTOFO,
                      @V_PGTO_NRDIAPGFIXFO = NRDIAPGFIXFO,
                      @V_PGTO_IDUTDIAPGTFO = IDUTDIAPGTFO,
                      @V_PGTO_IDTPDESCFORN = IDTPDESCFORN,
                      @V_PGTO_VRPEDESCFORN = VRPEDESCFORN,
                      @V_PGTO_IDTPFRETFORN = IDTPFRETFORN
                   FROM
                      FORNECEDOR
                   WHERE
                      CDFORNECED = @V_ITEMCOLE_CDFORNECED;

                   UPDATE ITEMCOLE
                   SET
                      CDFORMPGTO   = @V_PGTO_CDFORMPGTO,
                      IDTPFOPGTCOL = @V_PGTO_IDTPFORPGTFO,
                      NRDIAPGFXCOL = @V_PGTO_NRDIAPGFIXFO,
                      NRPARCPGTCOL = @V_PGTO_NRPARCPGTOFO,
                      IDUTDIAPGCOL = @V_PGTO_IDUTDIAPGTFO
                   WHERE
                      CDFILIAL    = @V_ITEMCOLE_CDFILIAL   AND
                      NRCOLEPRECO = @V_ITEMCOLE_NRCOLEPRECO AND
                      CDPRODUTO   = @V_ITEMCOLE_CDPRODUTO  AND
                      CDMARCA     = @V_ITEMCOLE_CDMARCA    AND
                      CDFORNECED  = @V_ITEMCOLE_CDFORNECED AND
                      CDREGIAO    = @V_ITEMCOLE_CDREGIAO;
                   IF @V_PGTO_IDTPFORPGTFO = 'V' BEGIN
                      INSERT INTO PZOPGTITMCOL
                        (CDFILIAL, NRCOLEPRECO, CDFORNECED, CDPRODUTO,
                        CDMARCA, CDREGIAO, NRDIASPGTCOL, VRPERCPGTCOL)
                      SELECT
                         @V_ITEMCOLE_CDFILIAL,
                         @V_ITEMCOLE_NRCOLEPRECO,
                         @V_ITEMCOLE_CDFORNECED,
                         @V_ITEMCOLE_CDPRODUTO,
                         @V_ITEMCOLE_CDMARCA,
                         @V_ITEMCOLE_CDREGIAO,
                         PRAZOPGTFORN.NRDIASPGTOFO,
                         PRAZOPGTFORN.VRPERCPGTOFO
                      FROM
                         PRAZOPGTFORN
                      WHERE
                         PRAZOPGTFORN.CDFORNECED = @V_ITEMCOLE_CDFORNECED;
                   END;
                END
                ELSE
                BEGIN
                   UPDATE ITEMCOLE
                   SET
                      CDFORMPGTO   = @V_PGTO_CDFORMPGTO,
                      IDTPFOPGTCOL = @V_PGTO_IDTPFORPGPRF,
                      NRDIAPGFXCOL = @V_PGTO_NRDIAPGFIPRF,
                      NRPARCPGTCOL = @V_PGTO_NRPARCPGTPRF,
                      IDUTDIAPGCOL = @V_PGTO_IDUTDIAPGPRF
                   WHERE
                      CDFILIAL    = @V_ITEMCOLE_CDFILIAL   AND
                      NRCOLEPRECO = @V_ITEMCOLE_NRCOLEPRECO AND
                      CDPRODUTO   = @V_ITEMCOLE_CDPRODUTO  AND
                      CDMARCA     = @V_ITEMCOLE_CDMARCA    AND
                      CDFORNECED  = @V_ITEMCOLE_CDFORNECED AND
                      CDREGIAO    = @V_ITEMCOLE_CDREGIAO;
                   IF @V_PGTO_IDTPFORPGPRF = 'V' BEGIN
                      INSERT INTO PZOPGTITMCOL
                        (CDFILIAL, NRCOLEPRECO, CDFORNECED, CDPRODUTO,
                        CDMARCA, CDREGIAO, NRDIASPGTCOL, VRPERCPGTCOL)
                      SELECT
                         @V_ITEMCOLE_CDFILIAL,
                         @V_ITEMCOLE_NRCOLEPRECO,
                         @V_ITEMCOLE_CDFORNECED,
                         @V_ITEMCOLE_CDPRODUTO,
                         @V_ITEMCOLE_CDMARCA,
                         @V_ITEMCOLE_CDREGIAO,
                         PZOPGTPRFO.NRDIASPGPRFO,
                         PZOPGTPRFO.VRPERCPGPRFO
                      FROM
                         PZOPGTPRFO, PRODUTO
                      WHERE
                         PZOPGTPRFO.CDPRODUTO  = PRODUTO.CDPRODUTO AND
                         PZOPGTPRFO.CDFORNECED = @V_ITEMCOLE_CDFORNECED AND
                         @V_ITEMCOLE_CDARVPROD LIKE PRODUTO.CDARVPROD + '%';
                   END;
                END;

          /*################################# IMPOSTO #####################################*/
                SET @V_CDEMPRESA = NULL;
                SELECT
                   @V_CDEMPRESA = MAX(EMITENTEAF.CDEMPRESA)
                FROM
                   EMITENTEAF, PRODUTO
                WHERE
                   EMITENTEAF.CDPRODUTO = PRODUTO.CDPRODUTO AND
                   EMITENTEAF.CDFILIAL = @P_CDFILIAL AND
                   @V_ITEMCOLE_CDARVPROD LIKE PRODUTO.CDARVPROD + '%';

                --EXEC EMITENTE @P_CDFILIAL, @V_ITEMCOLE_CDPRODUTO, @V_ITEMCOLE_CDFORNECED;

                --SELECT @V_CDEMPRESA = SUBSTRING(EMITENTE @P_CDFILIAL, @V_ITEMCOLE_CDPRODUTO, @V_ITEMCOLE_CDFORNECED), 3, 2) AS CDEMPRESA
                  --FROM PARAMGERAL;

                IF @V_CDEMPRESA IS NULL BEGIN
                   SET @V_CDEMPRESA = NULL;
                   SELECT
                      @V_CDEMPRESA = MAX(PARCMPSUP.CDEMPRESA)
                   FROM
                      PARCMPSUP
                   WHERE
                      PARCMPSUP.CDFILIAL = @P_CDFILIAL;
                END;

                SET @V_CDEMPRESA  = NULL;
                SET @V_CDINSCESTA = NULL;
                SELECT
                   @V_CDEMPRESA = MAX(EMPRESA.CDEMPRESA),
                   @V_CDINSCESTA = MIN(INSCRESTAD.CDINSCESTA)
                FROM
                   EMPRESA,
                   INSCRESTAD
                WHERE
                   EMPRESA.CDEMPRESA = @V_CDEMPRESA           AND
                   EMPRESA.CDEMPRESA = INSCRESTAD.CDEMPRESA;

                EXEC IMPOSTO_ITEMCOL @V_CDEMPRESA,        @V_CDINSCESTA,          @V_ITEMCOLE_CDFORNECED, @P_CDFILIAL,
                                     @V_NRCOLEPRECO,      @V_ITEMCOLE_CDFORNECED, @V_ITEMCOLE_CDREGIAO,   @V_ITEMCOLE_CDPRODUTO,
                                     @V_ITEMCOLE_CDMARCA, @P_DTCOLEPREC;

                DELETE ITEMCOLE
                WHERE
                   ITEMCOLE.NRCOLEPRECO <> @V_ITEMCOLE_NRCOLEPRECO AND
                   ITEMCOLE.CDFILIAL    =  @V_ITEMCOLE_CDFILIAL    AND
                   ITEMCOLE.CDPRODUTO   =  @V_ITEMCOLE_CDPRODUTO   AND
                   ITEMCOLE.CDMARCA     =  @V_ITEMCOLE_CDMARCA     AND
                   ITEMCOLE.CDFORNECED  =  @V_ITEMCOLE_CDFORNECED  AND
                   ITEMCOLE.CDREGIAO    =  @V_ITEMCOLE_CDREGIAO    AND
                   ITEMCOLE.DTINIVALITM =  @V_ITEMCOLE_DTNOVINIVAL AND
                   ITEMCOLE.DTFINVALITM =  @V_ITEMCOLE_DTNOVFINVAL;
             END
             ELSE
             BEGIN
                SET @P_COTA_N_DUP = 'S'+@V_NRCOLEPRECO;
                INSERT INTO LOGITEMCOLE
                  (CDFILIALLIC,
                   NRCOLEPRELIC,
                   CDMARCALIC,
                   CDREGIAOLIC,
                   CDFORNECELIC,
                   CDPRODUTOLIC,
                   DTINIVALLIC,
                   DTFINVALLIC,
                   DTOPERACLIC,
                   IDOPERALIC,
                   DSMETUSULIC,
                   IDITMLISPLIC,
                   NRCOLEORILIC,
                   IDMOTIVNDUPL,
                   VRPRECANTLIC,
                   VRPRECDEPLIC)
                 VALUES
                  (@V_ITEMCOLE_CDFILIAL,
                   @V_ITEMCOLE_NRCOLEPRECO,
                   @V_ITEMCOLE_CDMARCA,
                   @V_ITEMCOLE_CDREGIAO,
                   @V_ITEMCOLE_CDFORNECED,
                   @V_ITEMCOLE_CDPRODUTO,
                   @V_ITEMCOLE_DTNOVINIVAL,
                   @V_ITEMCOLE_DTNOVFINVAL,
                   GETDATE(),
                   'N',
                   @V_DSMETUSULIC,
                   'N',
                   @V_NRCOLEORIG,
                   @V_IDMOTIVNDUPL,
                   @V_ITEMCOLE_VRPRECUNIITM,
                   @V_ITEMCOLE_VRPRECUNIITM);
             END;
             
             UPDATE ITEMCOLE
                SET IDTPFOPGTCOL  = IDTPFOPGTCOL
              WHERE CDFILIAL    = @V_ITEMCOLE_CDFILIAL
                AND NRCOLEPRECO = @V_ITEMCOLE_NRCOLEPRECO
                AND CDFORNECED  = @V_ITEMCOLE_CDFORNECED
                AND CDREGIAO    = @V_ITEMCOLE_CDREGIAO
                AND CDPRODUTO   = @V_ITEMCOLE_CDPRODUTO
                AND CDMARCA     = @V_ITEMCOLE_CDMARCA;
          END;

          FETCH NEXT FROM C_ITEMCOLE INTO @V_ITEMCOLE_CDFILIAL,
                                          @V_ITEMCOLE_NRCOLEPRECO,
                                          @V_ITEMCOLE_CDFORNECED,
                                          @V_ITEMCOLE_CDREGIAO,
                                          @V_ITEMCOLE_CDPRODUTO,
                                          @V_ITEMCOLE_CDARVPROD,
                                          @V_ITEMCOLE_CDMARCA,
                                          @V_ITEMCOLE_CDTIPCOB,
                                          @V_ITEMCOLE_CDSEGMARCCOL,
                                          @V_ITEMCOLE_DTNOVINIVAL,
                                          @V_ITEMCOLE_DTNOVFINVAL,
                                          @V_ITEMCOLE_VRPRECUNIITM,
                                          @V_ITEMCOLE_VRPRECECOITM,
                                          @V_ITEMCOLE_VRPERDESITM,
                                          @V_ITEMCOLE_IDTIPFREITM,
                                          @V_ITEMCOLE_NRPZOENTCOL,
                                          @V_ITEMCOLE_CDFORMPGTO,
                                          @V_ITEMCOLE_IDTPFOPGTCOL,
                                          @V_ITEMCOLE_NRPARCPGTCOL,
                                          @V_ITEMCOLE_NRDIAPGFXCOL,
                                          @V_ITEMCOLE_IDUTDIAPGCOL,
                                          @V_ITEMCOLE_DSPZOPGTCONC,
                                          @V_ITEMCOLE_IDSITUCADA,
                                          @V_ITEMCOLE_CDQUALIF,
                                          @V_ITEMCOLE_IDFORNAUTO,
                                          @V_ITEMCOLE_DTVALQUALIF;

       END;
       CLOSE C_ITEMCOLE;
       DEALLOCATE C_ITEMCOLE;

       FETCH NEXT FROM C_REGIAO INTO @V_CDREGIAO;
    END;                     
    CLOSE C_REGIAO;
    DEALLOCATE C_REGIAO;

--    COMMIT;
    
--    UPDATE ITEMCOLE
--      SET IDTPFOPGTCOL = IDTPFOPGTCOL
--      WHERE
--       CDFILIAL    = @P_CDFILIAL AND
--       NRCOLEPRECO = @V_NRCOLEPRECO;

--    IF @@ROWCOUNT = 0 BEGIN
--       DELETE
--          COLETAPR
--       WHERE
--          CDFILIAL    = @P_CDFILIAL AND
--          NRCOLEPRECO = @V_NRCOLEPRECO;
--    END;

    FETCH NEXT FROM C_COTACAO INTO @V_NRCOLEORIG,
                                   @V_CDOPERADOR,
                                   @V_IDDISMONTLIS
  END;
  CLOSE C_COTACAO;
  DEALLOCATE C_COTACAO;
  
  SET @V_CONTADOR = 0;

  DECLARE C_LIMPEZA CURSOR FOR
     SELECT CDFILIAL, NRCOLEPRECO
       FROM COLETAPR
      WHERE DTINIVALCOL >= @P_DTINIVALCOL
        AND DTFINVALCOL <= @P_DTFINVALCOL
        AND NOT EXISTS (SELECT 1
                          FROM ITEMCOLE
                         WHERE ITEMCOLE.CDFILIAL    = COLETAPR.CDFILIAL
                           AND ITEMCOLE.NRCOLEPRECO = COLETAPR.NRCOLEPRECO);

  OPEN C_LIMPEZA;
  FETCH NEXT FROM C_LIMPEZA INTO @V_LIMPEZA_CDFILIAL, @V_LIMPEZA_NRCOLEPRECO

  WHILE (@@FETCH_STATUS = 0)
  BEGIN
    DELETE
      FROM COLETAPR
     WHERE CDFILIAL    = @V_LIMPEZA_CDFILIAL
       AND NRCOLEPRECO = @V_LIMPEZA_NRCOLEPRECO;
       
    SET @V_CONTADOR = @V_CONTADOR + 1;

    IF @V_CONTADOR >= 500 BEGIN
       SET @V_CONTADOR = 0;
--       COMMIT;
    END;              

    FETCH NEXT FROM C_LIMPEZA INTO @V_LIMPEZA_CDFILIAL, @V_LIMPEZA_NRCOLEPRECO;
  END;
  CLOSE C_LIMPEZA;
  DEALLOCATE C_LIMPEZA;
--  COMMIT;
END;


-- VERSAO --
EXEC ATUVEROBJ 'DUPLICA_COTACAO','6.10.000';
GO

